<template>
	<div class="restaurant" :style="!restaurant.open ? 'opacity: 0.3;' : null">
		<Thumbnail class="photo-thumbnail" @click.native="goTo(restaurant)" :src="restaurant.logo"></Thumbnail>
		<div class="plaque content-next">
			<div class="info" @click="goTo(restaurant)">
				<div class="info-top">
					<span>{{ restaurant.name }}</span>
				</div>
				<span class="description">{{ restaurant.description }}</span>
					<span v-if="restaurant.open == false"  class="description strong">
						<img width="15" height="15" src="~@/assets/icons/icon-clock.svg">
						{{ getOpenAt(restaurant.openAt) }} hrs. 
					</span>
				<div class="ahorro" v-if="restaurant.open">
					<p >#con 
						<span class="B">B</span>
						<span class="M">M</span>
						ahorras 
						<span class="porcentaje">{{restaurant.saving}}%</span>
					</p>
				</div>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'vue-property-decorator'
import Thumbnail from '@/components/Thumbnail.vue'
import Menu, { InfoBusiness, InfoTag } from '@/models/Menu'
import { TypeOrder } from '@/store/state'
import Localization from '@/models/Localization'

@Component({
	components: {
		Thumbnail,
	}
})
export default class CardList extends Vue {
	@Prop({ default: null }) readonly restaurant!: InfoBusiness

	async goTo(data: InfoBusiness){
		if (data.open){
			this.$emit('getInfo')
			await this.$store.dispatch('getRestaurant', data.restaurantId)
			await this.$store.dispatch('getMenu', data.id)
			await this.$store.dispatch('getDeliveryMenu', data.id)
			await this.$store.dispatch('setTypeOrder', TypeOrder.DELIVERY)
			await this.$store.dispatch('setNewOrder')
			const menu: Menu | undefined = this.$store.state.menu;
			if(menu){
				const localizations = menu.localizations
				const local = localizations.find(local => local.language == 'spanish')
				if (local) this.setLocalization(local)
			}
			await this.$router.push(`/menu`)
		}
	}

	setLocalization(localization: Localization){
        this.$store.dispatch('changeCurrency', localization.currency)
        this.$store.dispatch('changeLanguage', localization.language)
        this.$emit('select')
    }

	getTagStyle(infoTag: InfoTag){
		switch(infoTag){
			case InfoTag.FREESHIPPING:
				return `border: 1px solid #e51f2f; color: #e51f2f;`

			case InfoTag.PROX:
				return `border: 1px solid #000000; color: #000000;`

			case InfoTag.CLOSE:
				return `border: 1px solid #000000; color: #000000;`

			case InfoTag.DISCOUNT30:
				return `border: 1px solid #EF7F1A; color: #EF7F1A;`

			case InfoTag.DISCOUNT15:
				return `border: 1px solid #EF7F1A; color: #EF7F1A;`

			case InfoTag.DISCOUNT20:
				return `border: 1px solid #EF7F1A; color: #EF7F1A;`

			case InfoTag.DISCOUNT40:
				return `border: 1px solid #EF7F1A; color: #EF7F1A;`

			case InfoTag.DISCOUNT50:
				return `border: 1px solid #EF7F1A; color: #EF7F1A;`

			case InfoTag.PROMOCOMBO:
				return `border: 1px solid #EF7F1A; color: #EF7F1A;`

			case InfoTag.SHIPPING1:
				return `border: 1px solid #EF7F1A; color: #EF7F1A;`

			default:
				return
		}
	}

	getOpenAt(openAt: string) {
		const aux = new Date(openAt)
		const hour = aux.getHours()
		const minutes = aux.getMinutes()
		return 'Abre: ' + ('0' + hour).slice(-2) + ':' + ('0' + minutes).slice(-2)
	}
}
</script>

<style lang="scss" scoped>
.restaurant {
	display: inline-flex;
	margin: 0.2em 0;
	padding: 1em;
	width: 90%;
	background: #fbfcff;
	// background: red;
	font-family: 'Poppins', sans-serif;
	.plaque {
		display: flex;
		width: 70%;
		flex-direction: row;
		justify-content: space-around;
		.info {
			font-weight: bold;
			margin-right: auto;
			font-size: 14px;
			line-height: 21px;
			margin-left: 0.8em;
			width: 90%;
			.ahorro{
				p{
					text-align: center;
					margin: 0;
					.B{
						color:#EF7F1A;
					}
					.M{
						color: #000000;
					}
				}
				margin-top: 5%;
				opacity: 0.7;
				border: 1px solid #EF7F1A; 
				// color: #EF7F1A;
				background: #fff;
				border-radius: 6px;
			}
			.info-top{
				display: flex;
				justify-content: space-between;
				.puntuacion{
					display: flex;
					span{
						margin-left: 5px;
					}
				}
			}
			.description {
				font-weight: normal;
				color: #afafaf;
				font-size: 14px;
				line-height: 16px;
				overflow: hidden;
				display: -webkit-box;
				-webkit-line-clamp: 2;
				-webkit-box-orient: vertical;
			}
			.strong{
				color:#000000
			}
		}

		.seeProduct {
			width: 20px;
			height: 20px;
		}
	}
}

.content-next {
	margin: auto 0 !important;
}

.open-at {
	margin: auto 0 !important;
	font-size: 13px;
	font-weight: bold;
}

.photo-thumbnail {
	width: 95px;
	height: 90px;
	border-radius: 10px;
	margin: auto 0;
}

.centered {
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
}

.tags {
	background: #ffffff;
	border: 1px solid #000000;
	box-sizing: border-box;
	border-radius: 2px;
	width: 80%;
	margin-bottom: 0.2em;
	p {
		font-family: 'Poppins', sans-serif;
		font-style: normal;
		font-weight: 600;
		font-size: 12px;
		line-height: 18px;
		margin: 0px;
		color: #000000;
		text-align: center;
	}
}

.flex-space{
	display: flex;
    justify-content: space-between;
}
</style>
